using System;
using System.Threading;

// https://docs.microsoft.com/cs-cz/dotnet/api/system.threading.mutex?view=net-5.0

class TridaMutex
{
	static Mutex mutex = new Mutex(false, "nazev_mutexu");

	static void Main()
	{
		// 5 vteřin počká, pak se ukončí
		if (!mutex.WaitOne(TimeSpan.FromSeconds(5), false))
		{
			Console.WriteLine("Jiná instance této aplikace běží! Konec");
			return;
		}
		try
		{
			Console.WriteLine("Aplikace spuštěna - Stiskněte Enter pro ukončení");
			// ... kritická sekce ...
		}
		finally { mutex.ReleaseMutex(); }
	}
}
