#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define NUM_THREADS 5

void* vlakno(void* arg)
{
    int tid;

    tid = *((int *) arg);
    printf("Ahoj, tady je vlakno %d!\n", tid);

    for (i = 0; i < (0xFFFFFFFF); i++)
        ; // nějaká práce

    printf("Ahoj, vlakno %d konci!\n", tid);
    return NULL;
}

int main(void)
{
    pthread_t threads[NUM_THREADS];
    int thread_args[NUM_THREADS];
    int rc, i;

    // Vytvoření všech vláken
    for (i = 0; i < NUM_THREADS; i++) {
        thread_args[i] = i;
        rc = pthread_create(&threads[i], NULL, vlakno, &thread_args[i]);
        if (rc != 0) {
            printf("\nChyba, nelze vytvorit vlakno: [%s]", strerror(rc));
        }
    }

    // Čekání na dokončení všech vláken
    for (i = 0; i < NUM_THREADS; i++) {
        pthread_join(threads[i], NULL);
    }

    return 0;
}
